-- ==============================================================
-- File generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2013.4
-- Copyright (C) 2013 Xilinx Inc. All rights reserved.
-- 
-- ==============================================================


library IEEE;
use IEEE.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity fir_hw_add_51ns_51s_51_2_AddSubnS_0 is
port (
    clk: in std_logic;
    reset: in std_logic;
    ce: in std_logic;
    a: in std_logic_vector(50 downto 0);
    b: in std_logic_vector(50 downto 0);
    s: out std_logic_vector(50 downto 0));
end entity;

architecture behav of fir_hw_add_51ns_51s_51_2_AddSubnS_0 is
  component fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder is 
    port (
      faa : IN STD_LOGIC_VECTOR (26-1 downto 0);
      fab : IN STD_LOGIC_VECTOR (26-1 downto 0);
      facin : IN STD_LOGIC_VECTOR (0 downto 0);
      fas : OUT STD_LOGIC_VECTOR (26-1 downto 0);
      facout : OUT STD_LOGIC_VECTOR (0 downto 0));
  end component;
  component fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder_f is 
    port (
      faa : IN STD_LOGIC_VECTOR (25-1 downto 0);
      fab : IN STD_LOGIC_VECTOR (25-1 downto 0);
      facin : IN STD_LOGIC_VECTOR (0 downto 0);
      fas : OUT STD_LOGIC_VECTOR (25-1 downto 0);
      facout : OUT STD_LOGIC_VECTOR (0 downto 0));
  end component;


-- ---- register and wire type variables list here ----

-- wire for the primary inputs
  signal a_reg : std_logic_vector(50 downto 0);
  signal b_reg : std_logic_vector(50 downto 0);

-- wires for each small adder
  signal a0_cb : std_logic_vector(25 downto 0);
  signal b0_cb : std_logic_vector(25 downto 0);
  signal a1_cb : std_logic_vector(50 downto 26);
  signal b1_cb : std_logic_vector(50 downto 26);

-- registers for input register array
  type ramtypei0 is array (0 downto 0) of std_logic_vector(24 downto 0);
  signal a1_cb_regi1 : ramtypei0;
  signal b1_cb_regi1 : ramtypei0;

-- wires for each full adder sum
  signal fas : std_logic_vector(50 downto 0);

-- wires and register for carry out bit
  signal faccout_ini : std_logic_vector (0 downto 0);
  signal faccout0_co0 : std_logic_vector (0 downto 0); 
  signal faccout1_co1 : std_logic_vector (0 downto 0);

  signal faccout0_co0_reg : std_logic_vector (0 downto 0);

-- registers for output register array
  type ramtypeo0 is array (0 downto 0) of std_logic_vector(25 downto 0);
  signal s0_ca_rego0 : ramtypeo0; 

-- wire for the temporary output
  signal s_tmp : std_logic_vector(50 downto 0);

-- ---- RTL code for assignment statements/always blocks/module instantiations here ----
  begin
  a_reg <= a;
  b_reg <= b;

-- small adder input assigments
  a0_cb <= a_reg(25 downto 0);
  b0_cb <= b_reg(25 downto 0);
  a1_cb <= a_reg(50 downto 26);
  b1_cb <= b_reg(50 downto 26);

-- input register array
  process (clk)
    begin
      if (clk'event and clk='1') then
        if (ce='1') then
        a1_cb_regi1 (0) <= a1_cb;
        b1_cb_regi1 (0) <= b1_cb;
      end if;
    end if;
  end process;

-- carry out bit processing
  process (clk)
    begin
      if (clk'event and clk='1') then
        if (ce='1') then
      faccout0_co0_reg <= faccout0_co0;
      end if;
    end if;
  end process;


-- small adder generation 
  u0 : fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder
      port map
          (faa    => a0_cb,
          fab    => b0_cb,
          facin  => faccout_ini,
          fas    => fas(25 downto 0),
          facout => faccout0_co0);
    u1 : fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder_f
        port map
            (faa    => a1_cb_regi1(0),
            fab    => b1_cb_regi1(0),
            facin  => faccout0_co0_reg,
            fas    => fas(50 downto 26),
            facout => faccout1_co1);

  faccout_ini <= "0";

-- output register array
  process (clk)
    begin
      if (clk'event and clk='1') then
        if (ce='1') then
        s0_ca_rego0 (0) <= fas(25 downto 0);
      end if;
    end if;
  end process;

-- get the s_tmp, assign it to the primary output
  s_tmp(25 downto 0) <= s0_ca_rego0(0);
  s_tmp(50 downto 26) <= fas(50 downto 26);

  s <= s_tmp;

end architecture;

-- short adder
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


entity fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder is
generic(N : natural :=26);
port (
    faa : IN STD_LOGIC_VECTOR (N-1 downto 0);
    fab : IN STD_LOGIC_VECTOR (N-1 downto 0);
    facin : IN STD_LOGIC_VECTOR (0 downto 0);
    fas : OUT STD_LOGIC_VECTOR (N-1 downto 0);
    facout : OUT STD_LOGIC_VECTOR (0 downto 0));
end;

architecture behav of fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder is
    signal tmp : STD_LOGIC_VECTOR (N downto 0);
begin

  tmp <= std_logic_vector(unsigned(std_logic_vector(unsigned(std_logic_vector(resize(unsigned(faa),N+1))) + unsigned(fab))) + unsigned(facin));
  fas <= tmp(N-1 downto 0 );
  facout <= tmp(N downto N);

end behav;

-- the final stage short adder
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


entity fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder_f is
generic(N : natural :=25);
port (
    faa : IN STD_LOGIC_VECTOR (N-1 downto 0);
    fab : IN STD_LOGIC_VECTOR (N-1 downto 0);
    facin : IN STD_LOGIC_VECTOR (0 downto 0);
    fas : OUT STD_LOGIC_VECTOR (N-1 downto 0);
    facout : OUT STD_LOGIC_VECTOR (0 downto 0));
end;

architecture behav of fir_hw_add_51ns_51s_51_2_AddSubnS_0_fadder_f is
    signal tmp : STD_LOGIC_VECTOR (N downto 0);
begin

  tmp <= std_logic_vector(unsigned(std_logic_vector(unsigned(std_logic_vector(resize(unsigned(faa),N+1))) + unsigned(fab))) + unsigned(facin));
  fas <= tmp(N-1 downto 0 );
  facout <= tmp(N downto N);

end behav;

Library IEEE;
use IEEE.std_logic_1164.all;

entity fir_hw_add_51ns_51s_51_2 is
    generic (
        ID : INTEGER;
        NUM_STAGE : INTEGER;
        din0_WIDTH : INTEGER;
        din1_WIDTH : INTEGER;
        dout_WIDTH : INTEGER);
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        ce : IN STD_LOGIC;
        din0 : IN STD_LOGIC_VECTOR(din0_WIDTH - 1 DOWNTO 0);
        din1 : IN STD_LOGIC_VECTOR(din1_WIDTH - 1 DOWNTO 0);
        dout : OUT STD_LOGIC_VECTOR(dout_WIDTH - 1 DOWNTO 0));
end entity;

architecture arch of fir_hw_add_51ns_51s_51_2 is
    component fir_hw_add_51ns_51s_51_2_AddSubnS_0 is
        port (
            clk : IN STD_LOGIC;
            reset : IN STD_LOGIC;
            ce : IN STD_LOGIC;
            a : IN STD_LOGIC_VECTOR;
            b : IN STD_LOGIC_VECTOR;
            s : OUT STD_LOGIC_VECTOR);
    end component;




begin
    fir_hw_add_51ns_51s_51_2_AddSubnS_0_U :  component fir_hw_add_51ns_51s_51_2_AddSubnS_0
    port map (
        clk => clk,
        reset => reset,
        ce => ce,
        a => din0,
        b => din1,
        s => dout);

end architecture;


