`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    10:05:30 10/19/2012 
// Design Name: 
// Module Name:    top_level 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
// d:/xxx_hls/_src_hls
module top_level(
      input         clk_osc,
      input         rst_pin,
      
      output adc_mclk,
      output adc_bclk,
      output adc_lrclk,
      input  adc_din,

      output dac_mclk,
      output dac_bclk,
      output dac_lrclk,
      output dac_dout
);

wire clk, rst;
clk_gen clk_gen_0(
   .rst(rst_pin),
   .clk_in(clk_osc),
   .clk_out(clk),
   .rst_out(rst)
);

wire         adc_l_rd;
wire         adc_l_empty;
wire [23:0]  adc_l_data;
wire         adc_r_rd;
wire         adc_r_empty;
wire [23:0]  adc_r_data;
wire         dac_l_wr;
wire  [23:0] dac_l_data;
wire         dac_l_full;
wire         dac_r_wr;
wire  [23:0] dac_r_data;
wire         dac_r_full;
codec_if codec_if_0(
   .clk(clk),
   .rst(rst),
   
   .adc_mclk(adc_mclk),
   .adc_bclk(adc_bclk),
   .adc_lrclk(adc_lrclk),
   .adc_din(adc_din),

   .adc_l_rd(adc_l_rd),
   .adc_l_empty(adc_l_empty),
   .adc_l_data(adc_l_data),
   .adc_r_rd(adc_r_rd),
   .adc_r_empty(adc_r_empty),
   .adc_r_data(adc_r_data),

   .dac_l_wr(dac_l_wr),
   .dac_l_data(dac_l_data),
   .dac_l_full(dac_l_full),
   .dac_r_wr(dac_r_wr),
   .dac_r_data(dac_r_data),
   .dac_r_full(dac_r_full),

   .dac_mclk(dac_mclk),
   .dac_bclk(dac_bclk),
   .dac_lrclk(dac_lrclk),
   .dac_dout(dac_dout)
);

wire [23:0] fir_do_l;
wire [23:0] fir_do_r;
wire res_l_vld, res_r_vld;
wire input_l_ack, input_r_ack;
fir_hw fir_hw_i(
   .ap_clk(clk),
   .ap_rst(rst),
   
   .input_l_V(adc_l_data),
   .input_l_V_ap_vld(~adc_l_empty),
   .input_l_V_ap_ack(input_l_ack),
   
   .input_r_V(adc_r_data),
   .input_r_V_ap_vld(~adc_r_empty),
   .input_r_V_ap_ack(adc_r_ack),
   
   .res_l_V(fir_do_l),
   .res_l_V_ap_vld(res_l_vld),
   .res_l_V_ap_ack(dac_l_wr),
   
   .res_r_V(fir_do_r),
   .res_r_V_ap_vld(res_r_vld),
   .res_r_V_ap_ack(dac_r_wr)
);
assign adc_l_rd   = ~adc_l_empty & input_l_ack;
assign adc_r_rd   = ~adc_r_empty & input_r_ack;
assign dac_l_data = fir_do_l;
assign dac_r_data = fir_do_r;
assign dac_l_wr = res_l_vld & ~dac_l_full;
assign dac_r_wr = res_r_vld & ~dac_r_full;

//assign adc_l_rd   = ~adc_l_empty & ~dac_l_full;
//assign adc_r_rd   = ~adc_r_empty & ~dac_r_full;
//assign dac_l_data = adc_l_data;
//assign dac_r_data = adc_r_data;
//assign dac_l_wr   = ~adc_l_empty & ~dac_l_full;
//assign dac_r_wr   = ~adc_r_empty & ~dac_r_full;


endmodule
